#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 White
#property indicator_color2 Gold
#property indicator_color3 Orange
#property indicator_color4 Green 
#property indicator_color5 DarkViolet
#property indicator_color6 DeepSkyBlue
#property indicator_color7 SaddleBrown
#property indicator_color8 Black

extern datetime    SetTime=D'2012.07.20 12:00';

extern bool Currency_1 = true;
extern string Currency1    = "SILVER";
extern bool Inverse_C_1 = false;
extern bool Currency_2 = true;
extern string Currency2    = "GOLD";
extern bool Inverse_C_2 = false;
extern bool Currency_3 = false;
extern string Currency3    = "USDCHF";
extern bool Inverse_C_3 = false;
extern bool Currency_4 = false;
extern string Currency4    = "USDJPY";
extern bool Inverse_C_4 = false;
extern bool Currency_5 = false;
extern string Currency5    = "AUDUSD";
extern bool Inverse_C_5 = false;
extern bool Currency_6 = false;
extern string Currency6    = "USDCAD";
extern bool Inverse_C_6 = false;
extern bool Currency_7 = false;
extern string Currency7    = "NZDUSD";
extern bool Inverse_C_7 = false;
extern bool Currency_8_cross = false;
extern string Currency8_cross    = "GBPJPY";
extern bool Inverse_C_8_cross = false;

double buf1[], buf2[], buf3[], buf4[], buf5[], buf6[], buf7[], buf8[];

bool first=true; 

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init() {


  SetIndexBuffer(0, buf1);
  SetIndexLabel (0, Currency1);
  SetIndexStyle (0, DRAW_LINE, STYLE_SOLID, 1);
  SetIndexEmptyValue(0, 0);

  SetIndexBuffer(1, buf2);
  SetIndexLabel (1, Currency2);
  SetIndexStyle (1, DRAW_LINE, STYLE_SOLID, 1);
  SetIndexEmptyValue(1, 0);
  
  SetIndexBuffer(2, buf3);
  SetIndexLabel (2, Currency3);
  SetIndexStyle (2, DRAW_LINE, STYLE_SOLID, 1);
  SetIndexEmptyValue(2, 0);
  
  SetIndexBuffer(3, buf4);
  SetIndexLabel (3, Currency4);
  SetIndexStyle (3, DRAW_LINE, STYLE_SOLID, 1);
  SetIndexEmptyValue(3, 0);
  
  
  SetIndexBuffer(4, buf5);
  SetIndexLabel (4, Currency5);
  SetIndexStyle (4, DRAW_LINE, STYLE_SOLID, 1);
  SetIndexEmptyValue(4, 0);
  
  
  SetIndexBuffer(5, buf6);
  SetIndexLabel (5, Currency6);
  SetIndexStyle (5, DRAW_LINE, STYLE_SOLID, 1);
  SetIndexEmptyValue(5, 0);
  
  
  SetIndexBuffer(6, buf7);
  SetIndexLabel (6, Currency7);
  SetIndexStyle (6, DRAW_LINE, STYLE_SOLID, 1);
  SetIndexEmptyValue(6, 0);
  
  SetIndexBuffer(7, buf8);
  SetIndexLabel (7, Currency8_cross);
  SetIndexStyle (7, DRAW_LINE, STYLE_SOLID, 1);
  SetIndexEmptyValue(7, 0);
}


//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
void deinit() {
  Comment("");
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void start() {

  int sh=0;
  int counted_bars=IndicatorCounted();

  int shift=iBarShift(NULL,0,SetTime);
 
  if(first==true)
  {
   for(sh=0; sh<shift; sh++)
   {
    //Currency1    
    if(Currency_1==true)
    {
      if(Inverse_C_1==false)
      {
         buf1[sh]=((iClose(Currency1,0,sh) - iClose(Currency1,0,shift))/(iClose(Currency1,0,shift)))*100;
      }
      else
      {
         buf1[sh]=(((1/iClose(Currency1,0,sh)) - (1/iClose(Currency1,0,shift)))/((1/iClose(Currency1,0,shift))))*100;
      }
    }
    //Currency2    
    if(Currency_2==true)
    {
      if(Inverse_C_2==false)
      {
         buf2[sh]=((iClose(Currency2,0,sh) - iClose(Currency2,0,shift))/(iClose(Currency2,0,shift)))*100;
      }
      else
      {
         buf2[sh]=(((1/iClose(Currency2,0,sh)) - (1/iClose(Currency2,0,shift)))/((1/iClose(Currency2,0,shift))))*100;
      }
    }
    //Currency3    
    if(Currency_3==true)
    {
      if(Inverse_C_3==false)
      {
         buf3[sh]=((iClose(Currency3,0,sh) - iClose(Currency3,0,shift))/(iClose(Currency3,0,shift)))*100;
      }
      else
      {
         buf3[sh]=(((1/iClose(Currency3,0,sh)) - (1/iClose(Currency3,0,shift)))/((1/iClose(Currency3,0,shift))))*100;
      }
    }
    //Currency4    
    if(Currency_4==true)
    {
      if(Inverse_C_4==false)
      {
         buf4[sh]=((iClose(Currency4,0,sh) - iClose(Currency4,0,shift))/(iClose(Currency4,0,shift)))*100;
      }
      else
      {
         buf4[sh]=(((1/iClose(Currency4,0,sh)) - (1/iClose(Currency4,0,shift)))/((1/iClose(Currency4,0,shift))))*100;
      }
    }
    //Currency5    
    if(Currency_5==true)
    {
      if(Inverse_C_5==false)
      {
         buf5[sh]=((iClose(Currency5,0,sh) - iClose(Currency5,0,shift))/(iClose(Currency5,0,shift)))*100;
      }
      else
      {
         buf5[sh]=(((1/iClose(Currency5,0,sh)) - (1/iClose(Currency5,0,shift)))/((1/iClose(Currency5,0,shift))))*100;
      }
    }
    //Currency6    
    if(Currency_6==true)
    {
      if(Inverse_C_6==false)
      {
         buf6[sh]=((iClose(Currency6,0,sh) - iClose(Currency6,0,shift))/(iClose(Currency6,0,shift)))*100;
      }
      else
      {
         buf6[sh]=(((1/iClose(Currency6,0,sh)) - (1/iClose(Currency6,0,shift)))/((1/iClose(Currency6,0,shift))))*100;
      }
    }
    //Currency7    
    if(Currency_7==true)
    {
      if(Inverse_C_7==false)
      {
         buf7[sh]=(((iClose(Currency7,0,sh) - iClose(Currency7,0,shift))/(iClose(Currency7,0,shift)))*100);
      }
      else
      {
         buf7[sh]=((((1/iClose(Currency7,0,sh)) - (1/iClose(Currency7,0,shift)))/((1/iClose(Currency7,0,shift))))*100);
      }
    }
    //Currency8    
    if(Currency_8_cross==true)
    {
      if(Inverse_C_8_cross==false)
      {
         buf8[sh]=(((iClose(Currency8_cross,0,sh) - iClose(Currency8_cross,0,shift))/(iClose(Currency8_cross,0,shift)))*100)+(((iClose(Currency1,0,sh) - iClose(Currency1,0,shift))/(iClose(Currency1,0,shift)))*100);
      }
      else
      {
         buf8[sh]=((((1/iClose(Currency8_cross,0,sh)) - (1/iClose(Currency8_cross,0,shift)))/((1/iClose(Currency8_cross,0,shift))))*100)+(((iClose(Currency1,0,sh) - iClose(Currency1,0,shift))/(iClose(Currency1,0,shift)))*100);
      }
    }
   }
   first=false;
  }
  
  
  // REAL TIME
  if(first==false)
  {
    //Currency1    
    if(Currency_1==true)
    {
      if(Inverse_C_1==false)
      {
         buf1[0]=((iClose(Currency1,0,0) - iClose(Currency1,0,shift))/(iClose(Currency1,0,shift)))*100;
      }
      else
      {
         buf1[0]=(((1/iClose(Currency1,0,0)) - (1/iClose(Currency1,0,shift)))/((1/iClose(Currency1,0,shift))))*100;
      }
    }
    //Currency2    
    if(Currency_2==true)
    {
      if(Inverse_C_2==false)
      {
         buf2[0]=((iClose(Currency2,0,0) - iClose(Currency2,0,shift))/(iClose(Currency2,0,shift)))*100;
      }
      else
      {
         buf2[0]=(((1/iClose(Currency2,0,0)) - (1/iClose(Currency2,0,shift)))/((1/iClose(Currency2,0,shift))))*100;
      }
    }
    //Currency3    
    if(Currency_3==true)
    {
      if(Inverse_C_3==false)
      {
         buf3[0]=((iClose(Currency3,0,0) - iClose(Currency3,0,shift))/(iClose(Currency3,0,shift)))*100;
      }
      else
      {
         buf3[0]=(((1/iClose(Currency3,0,0)) - (1/iClose(Currency3,0,shift)))/((1/iClose(Currency3,0,shift))))*100;
      }
    }
    //Currency4    
    if(Currency_4==true)
    {
      if(Inverse_C_4==false)
      {
         buf4[0]=((iClose(Currency4,0,0) - iClose(Currency4,0,shift))/(iClose(Currency4,0,shift)))*100;
      }
      else
      {
         buf4[0]=(((1/iClose(Currency4,0,0)) - (1/iClose(Currency4,0,shift)))/((1/iClose(Currency4,0,shift))))*100;
      }
    }
    //Currency5    
    if(Currency_5==true)
    {
      if(Inverse_C_5==false)
      {
         buf5[0]=((iClose(Currency5,0,0) - iClose(Currency5,0,shift))/(iClose(Currency5,0,shift)))*100;
      }
      else
      {
         buf5[0]=(((1/iClose(Currency5,0,0)) - (1/iClose(Currency5,0,shift)))/((1/iClose(Currency5,0,shift))))*100;
      }
    }
    //Currency6    
    if(Currency_6==true)
    {
      if(Inverse_C_6==false)
      {
         buf6[0]=((iClose(Currency6,0,0) - iClose(Currency6,0,shift))/(iClose(Currency6,0,shift)))*100;
      }
      else
      {
         buf6[0]=(((1/iClose(Currency6,0,0)) - (1/iClose(Currency6,0,shift)))/((1/iClose(Currency6,0,shift))))*100;
      }
    }
    //Currency7    
    if(Currency_7==true)
    {
      if(Inverse_C_7==false)
      {
         buf7[0]=(((iClose(Currency7,0,0) - iClose(Currency7,0,shift))/(iClose(Currency7,0,shift)))*100);
      }
      else
      {
         buf7[0]=((((1/iClose(Currency7,0,0)) - (1/iClose(Currency7,0,shift)))/((1/iClose(Currency7,0,shift))))*100);
      }
    }
    //Currency8    
    if(Currency_8_cross==true)
    {
      if(Inverse_C_8_cross==false)
      {
         buf8[0]=(((iClose(Currency8_cross,0,0) - iClose(Currency8_cross,0,shift))/(iClose(Currency8_cross,0,shift)))*100)+(((iClose(Currency1,0,0) - iClose(Currency1,0,shift))/(iClose(Currency1,0,shift)))*100);
      }
      else
      {
         buf8[0]=((((1/iClose(Currency8_cross,0,0)) - (1/iClose(Currency8_cross,0,shift)))/((1/iClose(Currency8_cross,0,shift))))*100)+(((iClose(Currency1,0,0) - iClose(Currency1,0,shift))/(iClose(Currency1,0,shift)))*100);
      }
    } 
  }
}

//+------------------------------------------------------------------+

